/*
 *
 * ExportSrc
 *
 * Copyright (c) 2002, matsumo
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author may be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * -----------------------------------------------------------------------------
 *
 * () ȉ͓{̕₷l̂߂ɁAp̒쌠\
 * ͂łBȒ쌠́Ap̌{ɏ]B
 *
 * ExportSrc
 *
 * Copyright (c) 2002, matsumo
 * All rights reserved.
 *
 * ύX̗Lɂ炸A\[XуoCi`̍ĔzzїṕA
 * ȉ̏𖞂Ă΁AB
 *
 * 1. \[XER[h̍ĔzźAL̒쌠\ȀځAсA
 * ȉ̖ƐӎۑȂ΂ȂȂB
 *
 * 2. oCi`̍ĔzźAL̒쌠\ȀځAсA
 * ̖ƐӎA̔zzɕtA邢͂̑̎̂
 * ɖLȂ΂ȂȂB
 *
 * 3. Oēʂɋ𓾂ȂÃ\tgEFAhi
 * ̔î߂ɁA̒쌠Җ𗘗pĂ͂ȂȂB
 *
 * ̃\tgEFÁû܂܂̌`Łv񋟂AI邢͌O̕ۏ
 * ́AppѓړIւ̓Kɑ΂錾O̕ۏ؂܂݁A܂
 * Ɍ炸A݂ȂBƂȉ̂悤ȑQ̉\Ă
 * ƂĂAǂ̂悤Ȍ`ɂ낱̃\tgEFA̗p甭
 * āA̒쌠҂́A(֐iT[rX̒B; pAf[^A
 * 邢͗v̑; 邢͉cƂ̒f܂ށA܂炾Ɍ炸)
 * ړIɁAԐړIɁARɁAʂɁAA邢́AKRIɐĂ܂
 * Qɑ΂ӔC͂ȂAȂӔC_ł_̗LɌW炸
 * ȐӔC͂ȂA܂(ߎ邢͂̑܂)s@sׂɑ΂ĂӔC͂
 * B
 *
 */

/*
 * NX}\[X𐶐DynamicDrawpvOC
 *   ExportSrc.dll
 *
 *   ClassInfo	:NX̕ێA\[Xւ̕ϊsNX
 *
 * Copyright (c) 2002 matsumo. All rights reserved.
 *
 * @(#) $Id: ClassInfo.h,v 1.5 2002/07/04 10:49:34 matsumo Exp $
 *
 */

#ifndef __ClassInfo_h
#define __ClassInfo_h

#include "error.h"

#define CI_ATTR_STATIC		1
#define CI_ATTR_ABSTRACT	2

class ClassInfo{
public:
	BOOL setName(const wstring &str);
	BOOL setAttribute(FCRichTextExp* pRT);
	BOOL setOperation(FCRichTextExp* pRT);
	ES_Err::code write(const wstring &filename);

	static wstring getVisibility(wstring &str);
	static wstring divString(wstring &str, wchar_t token);
	int checkAbstract();

	//NX̊ei[
	class Name{
	public:
		wstring stereo_type;	//XeI^Cv
		wstring name;			//NX
		wstring tagged_value;	//
	};
	//̊ei[
	class Attribute{
	public:
		wstring visibility;		//F
		wstring name;			//ϐ
		wstring type;			//^
		wstring default_value;	//l
		BOOL    bStatic;		//TRUE=static錾
		Attribute(wstring &str, int attr);
	};
	//\bḧ̊ei[
	class Param{
	public:
		wstring name;			//ϐ
		wstring type;			//^
		wstring default_value;	//ftHgl
		Param(wstring &str);
	};
	//\bh̊ei[
	class Operation{
	public:
		wstring visibility;		//F
		wstring name;			//\bh
		vector<Param> param;	//
		wstring return_type;	//߂l
		wstring default_value;	//ftHgl
		BOOL    bStatic;		//TRUE=static錾
		BOOL    bAbstract;		//TRUE=abstract錾
		Operation(wstring &str, int attr);
	};

	Name name;						//NX
	vector<Attribute> attribute;	//̈ꗗ
	vector<Operation> operation;	//\bḧꗗ
	vector<wstring> header;			//wb_[ɒǉ镶
	wstring package;				//pbP[W
	vector<wstring> generalization;	//ĉ(pNX)
	vector<wstring> realization;	//(CvgNX)
//	vector<wstring> association;	//֘A
//	vector<wstring> dependence;		//ˑ
//	vector<wstring> aggregate;		//W

	vector<wstring> source;			//ϊ̃\[X

protected:
	static wstring &trim(wstring &str);
	static wstring &LF2CRLF(wstring &str);
	static void GetAttr(FCRichTextExp* pRT, vector<int>& vattr);
};

#endif//__ClassInfo_h
